import '/models/basico_model.dart';
import '../services/services.dart';

class Mesa extends Basico {
  int? idSucursal;
  String? nombre;
  String? clave;
  String? posicion;
  bool? activa;

  Mesa(
      {super.id,
      super.idLocal,
      this.idSucursal,
      this.nombre,
      this.clave,
      this.posicion,
      this.activa,
      super.creado,
      super.modificado,
      super.eliminado});

  @override
  Map<String, dynamic> toJson() {
    return {
      'id': id,
      'idSucursal': idSucursal ?? 0,
      'nombre': nombre ?? '',
      'clave': clave ?? '',
      'posicion': posicion ?? '',
      'activa': activa == true ? 1 : 0,
      'creado': creado?.toIso8601String(),
      'modificado': modificado?.toIso8601String(),
      'eliminado': eliminado?.toIso8601String(),
    }..addAll(super.toJson());
  }

  Mesa.fromJson(Map<String, dynamic> json) {
    super.parseJson(json);
    idSucursal = Basico.parseInt(json['idSucursal']);
    nombre = Basico.parseString(json['nombre']);
    clave = Basico.parseString(json['clave']);
    posicion = Basico.parseString(json['posicion']);
    activa = Basico.parseInt(json['activa']) == 1;
  }

  Mesa.fromApi(Map<String, dynamic> json) {
    super.parseJson(json);
    idSucursal = Basico.parseInt(json['idSucursal']);
    nombre = Basico.parseString(json['nombre']);
    clave = Basico.parseString(json['clave']);
    posicion = Basico.parseString(json['posicion']);
    if (json['activo'] is bool) {
      activa = json['activo'];
    } else {
      activa = Basico.parseInt(json['activo']) == 1;
    }
    creado = Basico.parseDate(json['creado']);
    modificado = Basico.parseDate(json['modificado']);
    eliminado = Basico.parseDate(json['eliminado']);
  }

  Future<void> guardar() async {
    idLocal = await RepoService().guardar(this);
  }
}
